/*                                                                          
  Ŀ
   Mascara.c                                                              
                                                                          
   Demostracin de la utilidad de las mscaras.                           
                                                                          
   Compilado con :  Borland C/C++ v3.1                                    
   Cdigo y texto:  [NoP] de Compiler SoftWare.                     
  1997 C.S.
*/

#include <stdio.h>                  /* funciones estndar Input/Output */
#include <stdlib.h>                 /* funcin exit() */
#include <dos.h>                    /* funcin pokeb(); */
#include <conio.h>                  /* funcin getch(); */
#include "libs\ints.h"              /* librera funciones varias int 10h */
#include "libs\mode13h.h"           /* librera funciones 320x200x256 */
#include "libs\palette.h"           /* librera funciones paleta */
#include "libs\sprites.h"           /* librera funciones sprites */

#include "graphics\acid.h"          /* bitmap de un acid y su paleta */

void LoadImage( char * );           /* carga de un fichero SCR */

unsigned int bucle;

/*  Funcin principal main()  */

void main( void )
{

 SetVideoMode( 3 );                       /* inicializar 80x25x16 (3h) */

 printf("MASCARA.EXE\r\n");
 printf("\r\nEste ejemplo pretende demostrar la utilidad y funcin de las mscaras en\r\n");
 printf("los sprites dibujando 2 bitmaps (uno con mscara y otro sin ella) sobre un\r\n");
 printf("fondo grfico, para apreciar los pixels transparentes que la mscara evita.\r\n\n");
 printf("Pulse cualquier tecla para realizar la prueba...");
 getch();

 SetVideoMode( 0x13 );                    /* inicializar 320x200x256 (13h) */
 LoadImage("GRAPHICS\\IMAGE1.SCR");       /* cargamos la imagen de fondo */
  
 DrawSpriteC_Mask( 240, 60, ancho_acid, alto_acid, 0, Acid, VGASEG );
 DrawSpriteC( 240, 120, ancho_acid, alto_acid, Acid, VGASEG );

 getch();                                 /* esperar a que pulse una tecla */
 SetVideoMode( 3 );                       /* inicializar 80x25x16 (3h) */
 printf("\r\nComo puede verse, la mscara permite eliminar la impresin de los pixels\r\n");
 printf("transparentes y as los sprites aparecen recortados sobre las imgenes y no\r\n");
 printf("sobreescribindolas debido al relleno rectangular del bitmap.\r\n\n");
}

/*-----------------------------------------------------------------------*/
void LoadImage( char *nombre ) 
{
FILE *fp;
char Paleta[768];
int x, y;

 fp = fopen( nombre, "rb" );
  if( fp == NULL )
   {
     SetVideoMode(3);
     printf("\r\n\aError abriendo fichero %s...\r\n", nombre );
     exit(1);
   }
                                           /* leemos la paleta del SCR */
  for(x=0; x<768; x++ )
   Paleta[x] = fgetc(fp);

  SetPalette( Paleta );                    /* paleta de la imagen ---> DAC */

  for(y=0; y<200; y++ )                    /* leemos el bitmap del SCR */
   for(x=0; x<320; x++ )
    PutPixel( x, y, fgetc(fp), VGASEG );

  fclose(fp);
}
